//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2014.08.29 at 12:55:12 PM CEST 
//


package net.ihe.gazelle.goc.xmm;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * <p>Java class for anonymous complex type.
 *
 * <p>The following schema fragment specifies the expected content contained within this class.
 *
 * <pre>
 * &lt;complexType&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element ref="{xmm}profileApplication" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element ref="{xmm}packagedElement" minOccurs="0"/&gt;
 *         &lt;element ref="{xmm}ownedRule" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element ref="{xmm}generalization" minOccurs="0"/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attribute name="name" use="required" type="{http://www.w3.org/2001/XMLSchema}NCName" /&gt;
 *       &lt;attribute ref="{xmm}id"/&gt;
 *       &lt;attribute ref="{xmm}type use="required""/&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 *
 * @author Abderrazek Boufahja
 * @version $Id: $Id
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "profileApplication",
    "packagedElements",
    "ownedRule",
    "generalization"
})
@XmlRootElement(name = "packagedElement")
public class PackagedElement {

    private List<ProfileApplication> profileApplication;
    
    @XmlElement(name = "packagedElement", namespace="")
    private List<PackagedElement> packagedElements;
    
    @XmlElement(name = "ownedRule", namespace="")
    private List<OwnedRule> ownedRule;
    
    @XmlElement(name = "generalization", namespace="")
    private Generalization generalization;
    @XmlAttribute(name = "name", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlSchemaType(name = "NCName")
    private String name;
    @XmlAttribute(name = "id", namespace = "http://schema.omg.org/spec/XMI/2.1")
    private String id;
    @XmlAttribute(name = "type", namespace = "http://schema.omg.org/spec/XMI/2.1", required = true)
    private String type;

    /**
     * Gets the value of the profileApplication property.
     *
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the profileApplication property.
     *
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getProfileApplication().add(newItem);
     * </pre>
     *
     *
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link net.ihe.gazelle.goc.xmm.ProfileApplication}
     *
     * @return a {@link java.util.List} object.
     */
    public List<ProfileApplication> getProfileApplication() {
        if (profileApplication == null) {
            profileApplication = new ArrayList<>();
        }
        return this.profileApplication;
    }

    /**
     * Gets the value of the packagedElement property.
     *
     * @return a {@link java.util.List} object.
     */
    public List<PackagedElement> getPackagedElements() {
    	if (packagedElements == null) {
    		this.packagedElements = new ArrayList<>();
    	}
        return packagedElements;
    }

    /**
     * Sets the value of the packagedElement property.
     *
     * @param value
     *     allowed object is
     *     {@link net.ihe.gazelle.goc.xmm.PackagedElement}
     */
    public void setPackagedElements(List<PackagedElement> value) {
        this.packagedElements = value;
    }

    /**
     * Gets the value of the ownedRule property.
     *
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the ownedRule property.
     *
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getOwnedRule().add(newItem);
     * </pre>
     *
     *
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link net.ihe.gazelle.goc.xmm.OwnedRule}
     *
     * @return a {@link java.util.List} object.
     */
    public List<OwnedRule> getOwnedRule() {
        if (ownedRule == null) {
            ownedRule = new ArrayList<>();
        }
        return this.ownedRule;
    }

    /**
     * Gets the value of the generalization property.
     *
     * @return a {@link net.ihe.gazelle.goc.xmm.Generalization} object.
     */
    public Generalization getGeneralization() {
        return generalization;
    }

    /**
     * Sets the value of the generalization property.
     *
     * @param value
     *     allowed object is
     *     {@link net.ihe.gazelle.goc.xmm.Generalization}
     */
    public void setGeneralization(Generalization value) {
        this.generalization = value;
    }

    /**
     * Gets the value of the name property.
     *
     * @return a {@link java.lang.String} object.
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     *
     * @param value
     *     allowed object is
     *     {@link java.lang.String}
     */
    public void setName(String value) {
        this.name = value;
    }

    /**
     * Gets the value of the id property.
     *
     * @return a {@link java.lang.String} object.
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     *
     * @param value
     *     allowed object is
     *     {@link java.lang.String}
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the type property.
     *
     * @return a {@link java.lang.String} object.
     */
    public String getType() {
        return type;
    }

    /**
     * Sets the value of the type property.
     *
     * @param value
     *     allowed object is
     *     {@link java.lang.String}
     */
    public void setType(String value) {
        this.type = value;
    }

}
